unit uTestThread;

interface

uses
  uSimpleThread, SysUtils;

type

  TTestThread = class;

  TOnTest = procedure(Sender: TTestThread) of object;

  TTestThread = class(TSimpleThread)
  private
    FSleepTime: Integer;
    FOnTest: TOnTest;
    FTaskCode: Integer;
    procedure Test;
    procedure DoTest;
    procedure SetSleepTime(val: Integer);
    procedure SetOnTest(val: TOnTest);
    procedure DoOnTest;
    procedure SetTaskCode(val: Integer);
  public
    procedure StartThread; override;
    property SleepTime: Integer read FSleepTime write SetSleepTime;
    property OnTest: TOnTest read FOnTest write SetOnTest;
    property TaskCode: Integer read FTaskCode write SetTaskCode;
  end;

implementation

{ TTestThread }

procedure TTestThread.DoOnTest;
begin
  if Assigned(FOnTest) then
    FOnTest(self);
end;

procedure TTestThread.DoTest;
begin

  if WaitStop then
    exit;

  DoOnStatusMsg('TestThread.TagID:' + IntToStr(TagID) + ',׼ݿȡ!');

  DoOnTest;
  // ˾䵱ȥݿȡ
  // е TestThread Ҫȥݿȡ
  // е̣߳ȡʱ򣬶ᱻһ߳ȥ

  if self.FTaskCode > 0 then
  begin
    DoOnStatusMsg('TestThread.TagID:' + IntToStr(TagID) + ',ѻ:' + IntToStr(FTaskCode));
    SleepExceptStopped(FSleepTime); // ˾䵱̵߳һ
    DoOnStatusMsg('TestThread.TagID:' + IntToStr(TagID) + ',!');
    Test;
  end
  else
  begin
    DoOnStatusMsg('TestThread.TagID:' + IntToStr(TagID) + ',δ,߳̽');
  end;

end;

procedure TTestThread.StartThread;
begin
  inherited;
  Test;
end;

procedure TTestThread.Test;
begin
  ExeProcInThread(DoTest);
end;

procedure TTestThread.SetSleepTime(val: Integer);
begin
  FSleepTime := val;
end;

procedure TTestThread.SetOnTest(val: TOnTest);
begin
  FOnTest := val;
end;

procedure TTestThread.SetTaskCode(val: Integer);
begin
  FTaskCode := val;
end;

end.
